=== debian/changelog ===
xen (4.8.3+xsa267+shim4.10.1+xsa267-1+deb9u9) stretch-security; urgency=high

  * Security upload [thanks to Wolodja Wentland]:
       XSA-264 (no CVE yet)
       XSA-265 (no CVE yet)
       XSA-266 (no CVE yet)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 22 Jun 2018 16:38:39 +0100

xen (4.8.3+xsa267+shim4.10.1+xsa267-1+deb9u8) stretch-security; urgency=high

  * Update to new upstream version 4.8.3+xsa267+shim4.10.1+xsa267.
       XSA-267 CVE-2018-3665

    I have actually taken upstream's staging-4.8 CI input branch, which is
    identical to the CI-tested stable-4.8 except that it also has the
    XSA-267 patches.  There are additional patches in upstream's
    stable-4.8 branch, beyond what was in the previous Debian stretch
    security update, which are prerequisites for the XSA-267 patches.

    For the shim, I have updated to upstream's staging-4.10, which is
    identical to the CI-tested stable-4.10q except, again, for
    XSA-267-related patches.  The 4.10.0-comet branch lacks speculation
    control entirely and has been superseded upstream.

 -- Ian Jackson <ian.jackson@citrix.com>  Mon, 18 Jun 2018 16:10:38 +0100

xen (4.8.3+xsa262+shim4.10.0+comet3-1+deb9u7) stretch-security; urgency=high

  * Include upstream XSA-263 (speculative store bypass) fixes for x86.
    I hear that ARM fixes will be forthcoming RSN.  Ie,
       XSA-263 CVE-2018-3639 (amd64/i386; armhf/arm64 still vuln.)

  * Include a number of upstream bugfixes, including fixes to previous
    security fixes, some of which are security-relevant:
      x86: correct ordering of operations during S3 resume
      x86: suppress BTI mitigations around S3 suspend/resume
      x86/spec_ctrl: Updates to retpoline-safety decision making
      x86/HPET: fix race triggering ASSERT(cpu < nr_cpu_ids)
      x86/HVM: never retain emulated insn cache when exiting back to guest
      xpti: fix bug in double fault handling
      x86/cpuidle: don't init stats lock more than once
      xen: Introduce vcpu_sleep_nosync_locked()
      xen/schedule: Fix races in vcpu migration
      x86: Fix "x86: further CPUID handling adjustments"

    The result is very similar to upstream staging-4.8.  However, as
    upstream staging-4.8 has not yet passed upstream CI, I have chosen to
    cherry pick fixes so that I can drop a couple that don't look
    immediately important.  We will expect to resynchronise with
    upstream's 4.8 stable branch soon.

  * Drop our patch `tools: fix arm build after bdf693ee61b48' (which was
    needed to build the upstream 4.8 comet branch on ARM but is not needed
    for the the upstream staging/stable branch).  Closes:#898898.

  * Update changelog for 4.8.3+xsa262+shim4.10.0+comet3-1+deb9u6 to
    mention branch switch from upstream 4.8 comet to upstream main 4.8,
    and add some missing CVEs.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 22 May 2018 18:41:33 +0100
