## xen 4.8.4

=== debian/changelog ===
xen (2001:4.8.4-7+deb10u1) buster; urgency=medium

  * Build for buster

 -- Marek Marczykowski-Górecki <user@build-debian4>  Tue, 20 Nov 2018 16:40:59 +0000

xen (2001:4.8.4-7) unstable; urgency=medium

  * Apply XSA-275

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 20 Nov 2018 12:49:12 +0100

xen (2001:4.8.4-6) unstable; urgency=medium

  * debian: compile fix for jessie
  * debian: reuse upstream orig tarball
  * Simplify hotplug locking mechanism, drop perl dependency

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 31 Oct 2018 02:38:20 +0100

xen (2001:4.8.4-5) unstable; urgency=medium

  * debian: make packages linked with new libxen-4.8 depdend on specific
    version

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 09 Oct 2018 18:34:38 +0200

xen (2001:4.8.4-4) unstable; urgency=medium

  * rpm: set PYTHON=python2
  * debian: fix changelog
  * debian: rework packaging to match Debian libxen-4.8 package
  * debian: package remaining files
  * debian: fix changelog
  * debian: use dh-systemd instead of manual systemctl call

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 08 Oct 2018 14:09:33 +0200

xen (2001:4.8.4-3) unstable; urgency=medium

  [ fepitre ]
  * Replace deprecated vwprintw function
  * Update travis for fc29
  * Update from python to python2
  * python3: better use python3_pkgversion rpm macro
  * Switch to python2-lxml for Fedora 29

  [ alcreator ]
  * Change emulated qemu usb controller to ehci and remove ifup/ifdown
    scripts

  [ Marek Marczykowski-Górecki ]
  * rpm: bump xen-hvm-stubdom-linux version requirement
  * travis: allow failures for archlinux build
  * Backport xenstore xs_watch() thread stack size fix

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 02 Oct 2018 03:58:00 +0200

xen (2001:4.8.4-2) unstable; urgency=medium

  [ unman ]
  * Allow build for artful in 4.0
  * Removed wheezy and trusty builds, consolidated Build-Depends
  * Fix typo in Debian Build-Depends

  [ Simon Gaiser ]
  * Update to staging-4.8 to get fixes for XSA-273
  * Disable SMT by default

  [ Marek Marczykowski-Górecki ]
  * Do not advance version to 4.8.5-pre

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 01 Sep 2018 16:04:40 +0200

xen (2001:4.8.4-1) --release; urgency=medium

  * travis: Add Archlinux build
  * version 4.8.4-1

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 16 Jul 2018 16:27:26 +0200

xen (2001:4.8.3-9) unstable; urgency=medium

  [ Frédéric Pierret ]
  * Fix %if for CentOS

  [ Marek Marczykowski-Górecki ]
  * Apply XSA-267 patches
  * Update context of XSA-267 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 13 Jun 2018 23:25:21 +0200

xen (2001:4.8.3-8) unstable; urgency=medium

  * Add/update prerequisites for XSA 263
  * Apply XSA 263 patches
  * travis: add Fedora 28 and Cent OS 7
  * Fix build on Debian buster

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 23 May 2018 16:20:18 +0200

xen (2001:4.8.3-7) wheezy; urgency=medium

  * Apply XSA 260-262
  * Fix context in XSA 260 patches

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 08 May 2018 23:23:59 +0200

xen (2001:4.8.3-6) unstable; urgency=medium

  [ Frédéric Pierret ]
  * Handle sources archives for submodules/subfolders which are needed
    for Mock build.

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 03 May 2018 13:05:09 +0200

xen (2001:4.8.3-5) unstable; urgency=medium

  [ Frédéric Pierret ]
  * add NO_ARCHIVE
  * Create spec.in
  * spec.in: add changelog placeholder

  [ Marek Marczykowski-Górecki ]
  * Apply gcc-8 fixes
  * Update core-vchan-xen submodule
  * travis: add fc27
  * rpm: require patched gcc only for dom0 build
  * rpm: typo fix

  [ Simon Gaiser ]
  * Add spec_ctrl patches from staging
  * Fix resume when using microcode update

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 17 Apr 2018 15:58:47 +0200

xen (2001:4.8.3-4) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Revert "Workaround for missing updated libgcc.i686"

  [ Simon Gaiser ]
  * Add upstream patches for improved early microcode loading

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 21 Mar 2018 02:37:22 +0100

xen (2001:4.8.3-3) unstable; urgency=medium

  [ Frédéric Pierret ]
  * Use %autosetup and prepare spec file for src.rpm

  [ Arjan Schrijver ]
  * Fix patches path to make Arch Linux PKGBUILD work again

  [ Marek Marczykowski-Górecki ]
  * travis: drop fc24 and fc25 VM test builds, enable testing repos

  [ Simon Gaiser ]
  * Add BTI mitigation patches from XSA 254
  * Adapt BTI patches to apply cleanly
  * Require gcc with BTI mitigation support

  [ Marek Marczykowski-Górecki ]
  * Workaround for missing updated libgcc.i686

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 02 Mar 2018 16:46:02 +0100

xen (2001:4.8.3-2) unstable; urgency=medium

  * libxl: workaround for backend domain shutdown without detaching
    device
  * libxl: init guest_evtchn and other structures for domain suspend

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 30 Jan 2018 01:24:03 +0100

xen (2001:4.8.3-1) unstable; urgency=medium

  [ Simon Gaiser ]
  * Add upstream backports for PVH

  [ Marek Marczykowski-Górecki ]
  * rpm: conflict with too old libvirt
  * travis: build also for buster
  * Fix debian-quilt handling empty lines
  * Do not patch .gitignore
  * Fix one libxl patch
  * Sync series-debian-vm.conf with series.conf

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 26 Jan 2018 20:53:40 +0100

xen (2001:4.8.2-12) unstable; urgency=medium

  [ Frédéric Pierret ]
  * Allow setting DISTFILES_MIRROR in the builder.conf

  [ Simon Gaiser ]
  * Backport elfloader fix to detect non PVH capable kernels

